/* vi:set sm ai

	message logging routine for CBA
						by ann@mrit.mei.co.jp

*/

#include "cba.h"

extern int term;
extern int trace;

char *msgfile = LOGFILE;

int
writemsg(class, line, p1, p2, p3, p4, p5, p6, p7, p8, p9)
    enum errclass class;
    char *line, *p1, *p2, *p3, *p4, *p5, *p6, *p7, *p8, *p9;
{
    FILE *fp;
    struct tm *ctm;

    struct timeval current;
    static char *ercls[] = {"SECUR", "SYSTM", "MAINT", "TRACE"};

    static char *moy[] = {"Jan", "Feb", "Mar", "Apr", "May", "Jun",
			  "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"};
    static int usestderr = 0;

    if (term)
	usestderr = 1;

    gettimeofday(&current, NULL);
    if (!msgfile)
    {
    	fputs("No message logging file\n", stderr);
	exit(-1);
    }

    fp = usestderr ? stderr : fopen(msgfile, "a");
    if (!fp)
    {
	fprintf(stderr, "Message logging file %s open failed.\n", msgfile);
	usestderr = 1;
	fp = stderr;
    }

    ctm = localtime((time_t *) &current.tv_sec);

    if (!usestderr)
	LOCKFILE(fileno(fp));

    fprintf(fp, "%s %2d ", moy[ctm->tm_mon], ctm->tm_mday);
    if (trace & TRACE_MODEM)
	fprintf(fp, "%2d:%02d:%02d.%03d ",
			ctm->tm_hour, ctm->tm_min, ctm->tm_sec,
			(int)(current.tv_usec/1000));
    else
	fprintf(fp, "%2d:%02d:%02d ", ctm->tm_hour, ctm->tm_min, ctm->tm_sec);

    fprintf(fp, "%s:%5d: ", ercls[class], (int)getpid());

    fprintf(fp, line, p1, p2, p3, p4, p5, p6, p7, p8, p9); 
    fflush(fp);

    if (!usestderr)
    {
	UNLKFILE(fileno(fp));
	fclose(fp);
    }

    return 0;
}

#if defined(NO_SYS_ERRLIST)
char *
cba_strerror(err)
    int err;
{
    static char cbuf[] = "Error code XXXXX";
    switch(err)
    {
#include "errlist"
    default:
    	sprintf(cbuf, "Error code %d", err);
	return cbuf;
    }
}
#endif


